import java.awt.*;
import java.util.*;

//-------------------------------------
public class Emitter {

public Color  tint;
public double life;
public double mspeed;
public int    msiz;
public int    numm;
public MoteAL motes;
public Random rndm;

//-------------------------------------
public Emitter(Random r) { 
  tint = new Color(255, 0, 0);
  life = 5.0;
  mspeed = 800.0;
  numm = 256;
  msiz = 4;
  motes = new MoteAL();
  rndm = r;
}

//-------------------------------------
public void Fire(Point p) { 
double mf, sr, vx, vy;
int  i;
Mote m;
  for (i=0; i<numm; i++) {
    m = new Mote();
    m.tint = tint;
    m.life = life+(rndm.nextDouble()/100);
    m.siz = msiz;
    m.px = p.x;
    m.py = p.y;
    vx = (rndm.nextDouble()-0.5);
    vy = (rndm.nextDouble()-0.5);
    sr = Math.sqrt((vx*vx)+(vy*vy));
    mf = rndm.nextDouble();
    m.mx = (vx/sr)*mspeed*mf;
    m.my = (vy/sr)*mspeed*mf;
    motes.add(m);
  }
}

//-------------------------------------
public void Render(Graphics g) { 
int  i, ne;
Mote m;
  ne = motes.size();
  for (i=0; i<ne; i++) {
    m = motes.get(i);
    g.setColor(m.tint);
    g.fillOval((int)m.px, (int)m.py, m.siz, m.siz);
  }
}

//-------------------------------------
public void Update(double et) { 
int  i, ne;
Mote m;
  ne = motes.size();
  for (i=ne-1; i>=0; i--) {
    m = motes.get(i);
    m.life -= et;
    if (m.life<0.0) motes.remove(i);
  }
  ne = motes.size();
  for (i=0; i<ne; i++) {
     m = motes.get(i);
     m.px += (m.mx*et);
     m.py += (m.my*et);
  }
}


//-------------------------------------
}
