import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.util.*;
import javax.swing.*;

//-------------------------------------
class RatRace extends JFrame implements Runnable, WindowListener {

static RatRace mf;

Canvas  cnvs;
JButton sbar;

//-------------------------------------
boolean doit, paus;
boolean gamo, mvpe, mvpn, mvps, mvpw, newg;
double  etim, gtim, itim, lsu;
Emitter emtr;
Font    uif;
Image   gimg, gimgs, pimg, pimgs, vimg, vimgs, wimg, wimgs;
int     gamx, gamy, maxx, maxy, uifs, wxp, wyp;
int     dsiz, gems, msiz, mult, ngem, plyx, plyy;
int     bx, by, idim, ix, iy;
Int2D   cells;
long    ctim, itck, otim;
Random  rndm;
String  stxt, uifn;
Thread  thrd;

//-------------------------------------
static final int UFSIZ   = 64;

static final String UIFNLIT = "UIFN";
static final String UIFSLIT = "UIFS";
static final String WXPLIT  = "WXP";
static final String WYPLIT  = "WYP";

static final int  MSIZ   = 13;
static final int  NORTH  = 1;
static final int  EAST   = 2;
static final int  SOUTH  = 4;
static final int  WEST   = 8;
static final int  INCSIZ = 4;
static final int  DRATIO = 3;
static final int  DISIZ  = 23;
static final int  MLTPLY = 5;
static final int  CPF    = 7;

static final double ITCK = 1.0;

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
class ANewGame implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  newg = true;
}}

//-------------------------------------
void AppQuit() {
  StopThread();
  System.exit(0);
}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  AppQuit();
}}

//-------------------------------------
int BorderedBy(int x, int y) {
int   rv;
  rv = 0;
  if (cells.Get(x, y-1)==1) rv++;
  if (cells.Get(x, y+1)==1) rv++;
  if (cells.Get(x-1, y)==1) rv++;
  if (cells.Get(x+1, y)==1) rv++;
  return(rv);
}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  PopupMain();
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
int kc;
  kc = ke.getKeyCode();
  if (kc == KeyEvent.VK_F1) PopupMain();
  if (kc == KeyEvent.VK_Q) AppQuit();
  if (mvpe||mvpn||mvps||mvpw) return;
  if (gamo) {
    if (kc == KeyEvent.VK_N) newg = true;
  } else {
    if (kc == KeyEvent.VK_LEFT) mvpw = true;
    if (kc == KeyEvent.VK_RIGHT) mvpe = true;
    if (kc == KeyEvent.VK_UP) mvpn = true;
    if (kc == KeyEvent.VK_DOWN) mvps = true;
  }
  cnvs.requestFocusInWindow();
}}

//-------------------------------------
class CBMouse extends MouseAdapter {
public void mouseClicked(MouseEvent me) {
int   x, y;
  if (gamo) return;
  if (mvpe||mvpn||mvps||mvpw) return;
  x = me.getX()/idim;
  y = me.getY()/idim;
  if ((x+bx)<plyx) mvpw = true;
  if ((x+bx)>plyx) mvpe = true;
  if ((y+by)<plyy) mvpn = true;
  if ((y+by)>plyy) mvps = true;
  cnvs.requestFocusInWindow();
}}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
  gamy = cnvs.getHeight();
  gamx = cnvs.getWidth();
  cnvs.requestFocusInWindow();
}}

//---------------------------------------------
boolean CellBlocked(int x, int y, int dir) {
boolean rv;
int     nx, ny;
  rv = true;
  if ((x==1)&&(y==1)) return(rv);
  nx = x;
  ny = y;
  if (dir==NORTH) ny -= 1;
  if (dir==SOUTH) ny += 1;
  if (dir==EAST)  nx += 1;
  if (dir==WEST)  nx -= 1;
  if ((nx<0)||(ny<0)) return(rv);
  if (cells.Get(nx, ny)!=1) rv = false;
  return(rv);
}

//---------------------------------------------
int CellEnclosed(int cc, int dir) {
int     cx, cy, dx, dy, mx, my, nc, nx, ny;
  nc = -1;
  dx = msiz/2;
  dy = msiz/2;
  cy = cc/dx;
  cx = cc-(cy*dx);
  nx = cx;
  ny = cy;
  if (dir==NORTH) ny -= 1;
  if (dir==SOUTH) ny += 1;
  if (dir==EAST)  nx += 1;
  if (dir==WEST)  nx -= 1;
  if ((nx<0)||(ny<0)) return(nc);
  if ((nx>=dx)||(ny>=dy)) return(nc);
  nc = (ny*dx)+nx;
  mx = (nx*2)+1;
  my = (ny*2)+1;
  if (cells.Get(mx, my-1)!=1) nc = -1;
  if (cells.Get(mx, my+1)!=1) nc = -1;
  if (cells.Get(mx-1, my)!=1) nc = -1;
  if (cells.Get(mx+1, my)!=1) nc = -1;
  return(nc);
}

//-------------------------------------
void CheckGame() {
int     total;
String  fs, msg;
  if ((gems==0)&&(plyx==1)&&(plyy==1)) {
    gamo = true;
    total = (ngem*msiz*msiz);
    fs = "You've Won! Score %d";
    msg = String.format(fs, total);
    sbar.setText(msg);
  }
}

//-------------------------------------
public void Initlz() {
Image     iimg;
Toolkit   tk;
URL       iurl;
  InitlzData();
  ReadIniFile();
  InitlzUI();
  LayoutUI();
  iurl = this.getClass().getResource("/RatRace.png");
  tk = Toolkit.getDefaultToolkit();
  iimg = tk.createImage(iurl);
  mf.setIconImage(iimg);
  StartThread();
  cnvs.requestFocusInWindow();
}

//-------------------------------------
public void InitlzData() {
Image     iimg;
Toolkit   tk;
URL       iurl;
  doit = false;
  paus = false;
  uifs = UFSIZ;
  uifn = "Sans";
  rndm = new Random();
  emtr = new Emitter(rndm);
  itim = 0.0;
  itck = 0;
  stxt = "Click Here";
  gamo = true;
  newg = false;
  mvpe = false;
  mvpn = false;
  mvps = false;
  mvpw = false;
  cells = new Int2D();
  plyx = 1;
  plyy = 1;
  gems = 0;
  msiz = MSIZ;
  dsiz = msiz/2;
  if (dsiz%2==0) dsiz++;
  mult = MLTPLY;
  ngem = 1;
  tk = Toolkit.getDefaultToolkit();
  iurl = this.getClass().getResource("/bricks.png");
  wimg = new ImageIcon(iurl).getImage();
  ix = wimg.getWidth(this);
  iy = wimg.getHeight(this);
  iurl = this.getClass().getResource("/player.png");
  pimg = new ImageIcon(iurl).getImage();
  iurl = this.getClass().getResource("/visited.png");
  vimg = new ImageIcon(iurl).getImage();
  iurl = this.getClass().getResource("/gem.png");
  gimg = new ImageIcon(iurl).getImage();
}

//-------------------------------------
public void InitlzUI() {
  gamx = (maxx*wxp)/100;
  gamy = (maxy*wyp)/100;
  uif = new Font(uifn, Font.BOLD, uifs);
  cnvs = new Canvas();
  cnvs.setBackground(new Color(64, 0, 0));
  cnvs.addKeyListener(new CBKey());
  cnvs.addMouseListener(new CBMouse());
  cnvs.addComponentListener(new CBResize());
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.addKeyListener(new CBKey());
  sbar.setBackground(new Color(128, 16, 16));
  sbar.setForeground(new Color(255, 255, 0));
}

//---------------------------------------------
void KnockDownWall(int fc, int tc) {
int   dimx, fmx, fmy, fx, fy, tmx, tmy, tx, ty;
  dimx = msiz / 2;
  fy = fc / dimx;
  fx = fc - (fy * dimx);
  fmx = (fx * 2) + 1;
  fmy = (fy * 2) + 1;
  ty = tc / dimx;
  tx = tc - (ty * dimx);
  tmx = (tx * 2) + 1;
  tmy = (ty * 2) + 1;
  if (fmx == tmx) {
    if (fmy < tmy) cells.Set(fmx, fmy+1, 0);
    else cells.Set(tmx, tmy+1, 0);
  } else {
    if (fmx < tmx) cells.Set(fmx+1, fmy, 0);
    else cells.Set(tmx+1, tmy, 0);
  }
}

//-------------------------------------
public void LayoutUI() {
  addWindowListener(this);
  mf.addKeyListener(new CBKey());
  mf.setSize(gamx, gamy+sbar.getHeight());
  mf.setLocation((maxx-gamx)/2, (maxy-(gamy+sbar.getHeight()))/2);
  mf.getContentPane().add(sbar, BorderLayout.NORTH);
  mf.getContentPane().add(cnvs, BorderLayout.CENTER);
  mf.setTitle("RatRace");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
}

//-------------------------------------
public static void main(String[] args) {
  System.out.println("starting RatRace\n");
  mf = new RatRace(args);
  mf.Initlz();
}

//-------------------------------------
void MoveEast() {
int		cell, cpf, numb, ox, oy;
  cpf = CPF;
  do {
    ox = plyx;
    oy = plyy;
    cell = cells.Get(plyx+1, plyy);
    if ((cell&1)!=0) mvpe = false;
    if (cell==8) gems--;
    if (mvpe) {
      plyx++;
      cells.Set(plyx, plyy, 4);
      cells.Set(ox, oy, 2);
      numb = BorderedBy(plyx, plyy);
      if (numb!=2) mvpe = false;
      cpf--;
    }
  } while((cpf>0)&&mvpe);
}

//-------------------------------------
void MoveNorth() {
int		cell, cpf, numb, ox, oy;
  cpf = CPF;
  do {
    ox = plyx;
    oy = plyy;
    cell = cells.Get(plyx, plyy-1);
    if ((cell&1)!=0) mvpn = false;
    if (cell==8) gems--;
    if (mvpn) {
      plyy--;
      cells.Set(plyx, plyy, 4);
      cells.Set(ox, oy, 2);
      numb = BorderedBy(plyx, plyy);
      if (numb!=2) mvpn = false;
      cpf--;
    }
  } while ((cpf>0)&&mvpn);
}

//-------------------------------------
void MoveSouth() {
int		cell, cpf, numb, ox, oy;
  cpf = CPF;
  do {
    ox = plyx;
    oy = plyy;
    cell = cells.Get(plyx, plyy+1);
    if ((cell&1)!=0) mvps = false;
    if (cell==8) gems--;
    if (mvps) {
      plyy++;
      cells.Set(plyx, plyy, 4);
      cells.Set(ox, oy, 2);
      numb = BorderedBy(plyx, plyy);
      if (numb!=2) mvps = false;
      cpf--;
    }
  } while ((cpf>0)&&mvps);
}

//-------------------------------------
void MoveWest() {
int		cell, cpf, numb, ox, oy;
  cpf = CPF;
  do {
    ox = plyx;
    oy = plyy;
    cell = cells.Get(plyx-1, plyy);
    if ((cell&1)!=0) mvpw = false;
    if (cell==8) gems--;
    if (mvpw) {
      plyx--;
      cells.Set(plyx, plyy, 4);
      cells.Set(ox, oy, 2);
      numb = BorderedBy(plyx, plyy);
      if (numb!=2) mvpw = false;
      cpf--;
    } 
  } while ((cpf>0)&& mvpw);
}

//-------------------------------------
void NewGame() {
ArrayList<Integer> cstk, nbor;
int   cc, csiz, i, j, mx, my, nc, nsiz, rv, tc, vc;
  msiz += INCSIZ;
  if (msiz>(dsiz*DRATIO)) {
    dsiz += 2;
  }
  SetupScaledImages();
  gamo = false;
  newg = false;
  gtim = 0.0f;
  lsu  = 0.0f;
  cells.SizeTo(msiz, msiz);
  mx = msiz/2;
  my = msiz/2;
  cstk = new ArrayList<Integer>();
  nbor = new ArrayList<Integer>();
  cstk.ensureCapacity(mx*my);
  nbor.ensureCapacity(4);
  for (i=0; i<msiz; i++) for (j=0; j<msiz; j++) cells.Set(i, j, 0);
  for (i=0; i<msiz; i+=2) for (j=0; j<msiz; j+=1) cells.Set(i, j, 1);
  for (j=0; j<msiz; j+=2) for (i=0; i<msiz; i+=1) cells.Set(i, j, 1);
  tc = mx * my;
  cc = rndm.nextInt(tc);
  vc = 1;
  cstk.clear();
  while (vc < tc) {
    nbor.clear();
    nc = CellEnclosed(cc, NORTH);
    if (nc!=-1) nbor.add(nc);
    nc = CellEnclosed(cc, EAST);
    if (nc!=-1) nbor.add(nc);
    nc = CellEnclosed(cc, SOUTH);
    if (nc!=-1) nbor.add(nc);
    nc = CellEnclosed(cc, WEST);
    if (nc!=-1) nbor.add(nc);
    nsiz = nbor.size();
    csiz = cstk.size();
    if (nsiz>0) {
      rv = rndm.nextInt(nsiz);
      nc = nbor.get(rv);
      KnockDownWall(cc, nc);
      cstk.add(cc);
      cc = nc;
      vc += 1;
    } else {
      cc = cstk.get(csiz - 1);
      cstk.remove(csiz - 1);
    }
  }
  plyx = msiz-2;
  plyy = msiz-2;
  cells.Set(plyx, plyy, 4);
  gems = 0;
  for (i=0; i<msiz; i++) {
    for (j=0; j<msiz; j++) {
      if (cells.Get(i,j)==0) {
        if (BorderedBy(i,j)==3) {
           cells.Set(i, j, 8);
           gems++;
        }
      }
    }
  }
  ngem = gems;
}

//-------------------------------------
void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("NewGame");
  mi.setMnemonic('N');
  mi.addActionListener(new ANewGame());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(sbar, 0, 0);
}

//-------------------------------------
public RatRace(String[] args) {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
  if (maxx>maxy) {
    wxp = 60;
    wyp = 90;
  } else {
    wxp = 90;
    wyp = 80;
  }
}

//-------------------------------------
void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"RatRace.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = jini;
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(UIFNLIT)==0) uifn = val;
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
      }
    }
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//------------------------------------
void RenderMaze(Graphics g) {
int   cell, dx, dy, i, isiz, j, jsiz;
  isiz = gamx/idim;
  jsiz = gamy/idim;
  bx = plyx - (isiz/2);
  by = plyy - (jsiz/2);
  if (bx<0) bx = 0;
  if (by<0) by = 0;
  if ((bx+isiz)>msiz) bx = msiz - isiz;
  if ((by+jsiz)>msiz) by = msiz - jsiz;
  for (i=0; i<isiz; i++) {
    for (j=0; j<jsiz; j++) {
      dx = i*idim;
      dy = j*idim;
      cell = cells.Get(i+bx,j+by);
      if (cell==1) g.drawImage(wimgs, dx, dy, null);
      if (cell==2) g.drawImage(vimgs, dx, dy, null);
      if (cell==4) g.drawImage(pimgs, dx, dy, null);
      if (cell==8) g.drawImage(gimgs, dx, dy, null);
    }
  }
}

//-------------------------------------
void RenderPS(Graphics g, double et) {
boolean doit;
int     rx, ry;
  itim += et;
  doit = false;
  if (itim>ITCK) {
    itim = 0.0;
    itck++;
    doit = true;
  }
  if (doit) {
    if ((itck%2)==0) {
      emtr.tint = new Color(255, 0, 0);
      emtr.life = 1.0;
      emtr.mspeed = 800.0;
      emtr.numm = 200;
      emtr.msiz = 4;
      rx = rndm.nextInt(gamx/2)+(gamx/4);
      ry = rndm.nextInt(gamy/2)+(gamy/4);
      emtr.Fire(new Point(rx, ry));
    }
    if ((itck%3)==0) {
      emtr.tint = new Color(0, 255, 0);
      emtr.life = 2.0;
      emtr.mspeed = 600.0;
      emtr.numm = 400;
      emtr.msiz = 8;
      rx = rndm.nextInt(gamx/2)+(gamx/4);
      ry = rndm.nextInt(gamy/2)+(gamy/4);
      emtr.Fire(new Point(rx, ry));
    }
    if ((itck%5)==0) {
      emtr.tint = new Color(0, 0, 255);
      emtr.life = 3.0;
      emtr.mspeed = 400.0;
      emtr.numm = 800;
      emtr.msiz = 12;
      rx = rndm.nextInt(gamx/2)+(gamx/4);
      ry = rndm.nextInt(gamy/2)+(gamy/4);
      emtr.Fire(new Point(rx, ry));
    }
  }
  emtr.Update(et);
  emtr.Render(g);
}

//---------------------------------------------
void RenderStatus(Graphics g) {
String  s;
  if ((gtim-lsu)<0.4) return;
  lsu = gtim;
  s = String.format("X %d Y %d | Gems %d | %d | %.02f", plyx, plyy, gems, msiz-2, gtim);
  sbar.setText(s);
}

//-------------------------------------
void RenderTextCentered(Graphics g, String s, Rectangle r, Font f) {
FontMetrics fm;
int         x, y;
  fm = g.getFontMetrics(f);
  x = r.x+(r.width-fm.stringWidth(s))/2;
  y = r.y+((r.height-fm.getHeight())/2)+fm.getAscent();
  g.setFont(f);
  g.drawString(s, x, y);
}

//-------------------------------------
public void run() {
BufferStrategy bs;
Graphics       g;
  cnvs.createBufferStrategy(2);
  bs = cnvs.getBufferStrategy();
  doit = true;
  while (doit) {
    ctim = System.nanoTime();
    etim = (ctim - otim)/1000000000.0;
    otim = ctim;
    if (!paus) {
      g = bs.getDrawGraphics();
      g.clearRect(0, 0, gamx, gamy);
      if (newg) NewGame();
      while (mvpe||mvpn||mvps||mvpw) {
        if (mvpe) MoveEast();
        if (mvpn) MoveNorth();
        if (mvps) MoveSouth();
        if (mvpw) MoveWest();
      }
      if (!gamo) {
        gtim += etim;
        RenderStatus(g);
        CheckGame();
        RenderMaze(g);
      } else RenderPS(g, etim);
      g.dispose();
      bs.show();
    }
    try {
       Thread.sleep(10);
    } catch (InterruptedException ex) {}
  }
}

//-------------------------------------
void SetupScaledImages() {
  if (gamy>gamx) idim = gamx/dsiz;
  else idim = gamy/dsiz;
  gimgs = gimg.getScaledInstance(idim, idim, Image.SCALE_AREA_AVERAGING);
  pimgs = pimg.getScaledInstance(idim, idim, Image.SCALE_AREA_AVERAGING);
  vimgs = vimg.getScaledInstance(idim, idim, Image.SCALE_AREA_AVERAGING);
  wimgs = wimg.getScaledInstance(idim, idim, Image.SCALE_AREA_AVERAGING);
}

//-------------------------------------
private void StartThread() {
  if ((thrd==null) || !doit) {
    otim = System.nanoTime();
    thrd = new Thread(this);
    thrd.start();
  }
}

//-------------------------------------
private void StopThread() {
  if (thrd!=null) {
    doit = false;
    try {
      thrd.join();
    } catch (InterruptedException ex) {}
    thrd = null;
  }
}

//-------------------------------------
public void windowActivated(WindowEvent e) { paus = false; }
public void windowDeactivated(WindowEvent e) { paus = true; }
public void windowDeiconified(WindowEvent e) { paus = false; }
public void windowIconified(WindowEvent e) { paus = true; }
public void windowClosing(WindowEvent e) { doit = false; }
public void windowClosed(WindowEvent e) { doit = false; }
public void windowOpened(WindowEvent e) { paus = false; }

//-------------------------------------
}
